const skills = {
    ...skill1,
    //食人魔技能
    '魂图-魂甲' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            const num = getNumByBag('灵石');
            if(num >= 10){
                reduceItem('灵石', 10);
                addItem('魂甲')
                return true;
            }else{
                const text = `灵石不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '有高人将锻造方法以灵魂碎片的形式记录于纸上，散落于世间各地，每一张图纸上的灵魂碎片只够锻造一次，一次后就成了白纸。消耗10枚灵石进行本次锻造'
    }),
    '魂图-魂刃' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            const num = getNumByBag('神性魂石');
            if(num >= 1){
                reduceItem('神性魂石', 1);
                addItem('魂刃')
                return true;
            }else{
                const text = `神性魂石不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '有高人将锻造方法以灵魂碎片的形式记录于纸上，散落于世间各地，每一张图纸上的灵魂碎片只够锻造一次，一次后就成了白纸。消耗1枚神性魂石进行本次锻造'
    }),
    '技能石：黄金风暴' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(data.gold < 2000){
                winMsg('金币不足', false, false);
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const monsterList = [];
            //获取怪物配置
            const mapName = data.map[data.location[1]][data.location[0]];//地图名
            const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
            //循环怪物配置
            for(let i = 0 ; i < 20 ; i++){
                for(const name in monsters){
                    const prob = monsters[name].prob;//出现概率
                    if(randomNum(1,100) <= prob){
                        if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1] && monsters[name].type !== '神话' && monsters[name].level <= data.level + 10){
                            monsterList.push(`${name}`);
                        }
                    }
                }
            }

            data.gold -= 2000;
            winMsg(`你使用了黄金风暴，${batchKillMonster(monsterList)}`)


            let addGold = monsterList.length * 3;
            if(addGold > 1000){
                addGold = 1000;
            }
            data.gold = parseFloat2Fiexd(data.gold);
            data.gold += addGold;        
            return true;
        },
        text : '消耗2000金币，贿赂一次魂师巫妖，使他发动一次灵魂屠戮并将奖励给你，且你获得杀敌数量*3的金币，最多不超过1000枚。奇迹的愿望之物。'
    }),
    '技能石：商界' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(data.inDungeon){
                winMsg(`在副本中不可打开仓库`, false, false);
                return false;
            }
            isGoblinExchange = true;
            renderGoblinExchange();
            $('.exchange').show();
            $('.item-use-win-modal').hide();
            $('.item-use-win').hide();
            return true;
        }, text : '打开一次哥布林商店，奇迹的愿望之物。'
    }),
    //山海系列技能
    '技能石：灾血盾' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
        if(hasStatus(data, '血甲')){
                winMsg('你的血甲尚未消耗完，无法续上', false, false);
                return false;
            }
            if(data.hp <= data.maxHp * 0.2){
                const text = `你的血量不足`;
                winMsg(text, false, false);
                return false;
            }
            data.hp -= data.maxHp * 0.2;

            data.atk += 30;
            addStatus(data, getStatus('血甲', {returnHarm : data.level, num : 10}));
            const addShield = data.maxHp * 0.3;
                data.shield += addShield;
                addBattleLog(`使用了灾血盾，获得${addShield}护盾`)
                return true;
            return true;
        },
        text : '灾祸血疫系列技能，消耗20%最大生命值，增加30攻击力，给自己附加血甲状态，敌人攻击你时会受到同等于你等级伤害，持续10回合，并获得一层最大血量x0.3倍的护盾'
    }),    
    '技能石：祸国-瘟疫' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(data.soul <= 3000){
                winMsg('血量不足', false, false);
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const monsterList = [];
            //获取怪物配置
            const mapName = data.map[data.location[1]][data.location[0]];//地图名
            const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
            //循环怪物配置
            for(let i = 0 ; i < 10 ; i++){
                for(const name in monsters){
                    const prob = monsters[name].prob;//出现概率
                    if(randomNum(1,100) <= prob){
                        if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 5 : 0) && monsters[name].level <= data.world.level[1] && monsters[name].type !== '神话' && monsters[name].type !== '传说' && monsters[name].level <= data.level + 10){
                            monsterList.push(`${name}`);
                        }
                    }
                }
            }

            data.hp -= 3000;
            winMsg(`你的瘟疫开始扩散，${batchKillMonster(monsterList)}`)


            let addSan = monsterList.length;
            if(addSan > 100){
                addSan = 100;
            }
            data.san += addSan;           
            return true;
        },
        text : '灾祸系列技能，在副本中不可使用，消耗3000点血量，对当前地形发动一次天灾瘟疫，将进行10次探索模拟，将其中模拟出现的等级不高于自己5级以上的除了神话与传说怪物之外的所有怪物全部击杀，并获得击杀奖励。'
    }),
    '技能石：七情皆恶' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
        if(data.battleMonster.qqje){
                winMsg('对方已经神智不清', false, false);
                return false;
            }
            if(data.battleMonster.nqyj){
                data.battleMonster.zyyj++;
            }else{
                data.battleMonster.zyyj = 1;
            }

                if(randomNum(1,100) <= data.battleMonster.zyyj * 7){                
                addStatus(data.battleMonster, getStatus('混乱', {harm : 500 * data.battleMonster.zyyj, keep : true}))
                data.battleMonster.maxHp -= (data.atk + data.def) * 0.1;
                if(data.battleMonster.maxHp <= 0){
                 battleWin();
                 }
                data.battleMonster.qqje = true;
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}的全部已全部污染`)
            }else{
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}向恶路行走`)
            }

            return true;

        },
        text : '罪业情欲系列技能，每次使用给对方附加1层罪业印记（战斗中不可见，但是实际存在），成功概率为罪业印记*7，成功时使怪物陷入混乱状态，每回合受到罪业印记*500的伤害，并使对方血量上限减少你的攻击加防御之合的10%，该状态不会自动消失。当使用成功后，本场战斗不可再次使用该技能。'
    }),
    '技能石：引灵破限' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('引灵破限', true)){
                return false;
            }
            const need = data.race.getLevelUpExp() - data.exp;
            if(getNumByBag('灵石') < 300){
                winMsg(`灵石不足`, false, false);
                return false;
            }
            if(getNumByBag('光粹') < 36){
                winMsg('光粹不足', false, false)
                return false;
            }

            reduceItem('灵石', 300)
            reduceItem('光粹', 36)
         
            if(need <= 3000){
            data.level += 1
            data.exp = 0
            }else{
            data.exp += need * 0.5;
            }        
            level();

            return true;
        }, text : '山海录大荒系列技能，消耗300灵石与25光粹，使经验值增加目前距离下一级所需经验的一半，当这个差距小于或等于3000时，直接提升一级，经验值清零。'
    }),
    '技能石：九重涅槃' : new Element({
        battleUse : true,
        weight : 1,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(data.battleMonster.jcnp >= 9){
                winMsg('阳神只能在短时间内涅槃9次',false,false)
                return false;
            }
       
            if(!data.battleMonster.jcnp){
                data.battleMonster.jcnp = 1;
            }else{

                data.battleMonster.jcnp += 1;
            }
            const addHp = data.maxHp
            removeAllDebuff(data)
            data.reduceHart += 0.06
            const text = `借用部分光粹并以特殊的方法吸收！，恢复${battleAddHp(data, addHp)}HP并烧尽了所有杂质`;
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },   
        text : '阳神的保命能力之一！恢复100%的血量，并清除所有负面状态，增加6%免伤，每场战斗只能使用9次'
    }),   
    '技能石：阳神剑法' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            return parseInt((data.maxHp / 5) + parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 3 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0)));
        },
        text : '生命上限每有5点，额外造成1点伤害，对对方造成这个伤害+人物攻击+武器攻击之和的3倍伤害，无视防御'
    }),
    '技能石：光能恢复' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('光能恢复', true)){
                return false;
            }
            let addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            addHp *= 1;
            const text = `使用了光能恢复，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return parseInt(((data.maxHp - data.hp) * 0.3) + (data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0))) * 1.5;
        },
        text : '借助太阳的力量，恢复当前已损失生命值30%加攻击力之合1.5倍的生命值'
    }),
     '技能石：山海诸界' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('山海诸界', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可打开仓库`, false, false);
                return false;
            }
            isGoblinExchange = true;
            renderGoblinExchange();
            $('.exchange').show();
            $('.item-use-win-modal').hide();
            $('.item-use-win').hide();
            return true;
        }, text : '山海图录种族技能，收集足够一定能量后可开启，里面可以无限制购买本界所有的物品，且出售时以半价出售物品。'
    }),
    '技能石：浴火重生' : new Element({
        battleUse : true,
        weight : 1,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(data.battleMonster.yhcs >= 3){
                winMsg('玄君只能在短时间内复活3次',false,false)
                return false;
            }
       
            if(!data.battleMonster.yhcs){
                data.battleMonster.yhcs = 1;
            }else{

                data.battleMonster.yhcs += 1;
            }
            const addHp = data.maxHp
            removeAllDebuff(data)
            data.reduceHart += 0.1
            const text = `浴火重生一次！，恢复${battleAddHp(data, addHp)}HP并焚烧掉大部分杂质`;
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },   
        text : '仿若金乌的自愈性！恢复100%的血量，并清除所有负面状态，增加10%免伤，每场战斗只能使用3次'
    }),   
    '技能石：斩魂' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            if(!checkRace('斩魂')){
                return 0;
            }
            return parseInt(data.maxHp / 10) + parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0));
        },
        text : '山海图录种族技能，生命上限每有10点，额外造成1点伤害'
    }),
    '技能石：自愈' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自愈', true)){
                return false;
            }
            let addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            addHp *= 1;
            const text = `使用了自愈，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return parseInt((data.maxHp - data.hp) * 0.1);
        },
        text : '山海图录种族技能，恢复当前已损失生命值10%的生命值'
    }),
    '技能石：逆流之河' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(data.battleMonster.nlzh){
                winMsg('能量暂时消耗完了',false,false)
                return false;
            }
                       
            data.battleMonster.nlzh = true;            
            
            const addHp = data.maxHp
            removeAllDebuff(data)
            data.san += 5;
            const text = `时空逆流，恢复${battleAddHp(data, addHp)}HP并驱散部分污染`;            
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '恢复100%的血量，并清除所有负面状态，理智增加5点，每场战斗只能使用1次'
    }), 
    '技能石：斩天破曜' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            return parseInt((data.maxHp / 10) + parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.5);
        },
        text : '生命上限每有10点，额外造成1+人物攻击+武器攻击之和的1.5倍伤害'
    }),
    
    '技能石：掠食' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            if(!checkRace('掠食')){
                return 0;
            }
            const rate = (data.race.name === '食人魔-暴食' || data.race.name === '食人魔-暴君') && data.battleMonster && data.battleMonster.items.filter(e => elementCfgs[e.name].isMeat).length > 0 ? 2 : 1;
            return rate * (parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1) + parseInt((data.maxHunger - data.hunger) / 5))
        },
        text : '对敌人额外造成(饥饿值上限-当前饥饿值)/5的伤害'
    }),
    '技能石：狂暴' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('狂暴', true)){
                return false;
            }
            if(data.battleMonster.kb){
                winMsg('你已经处于狂暴中了', false, false);
                return false;
            }

            data.battleMonster.kb = true;
            data.atk += parseInt(data.maxHunger / 5);
            data.def -= parseInt(data.maxHunger / 10);
            addBattleLog(`你使用了狂暴，攻击力增加${parseInt(data.maxHunger / 5)}，防御力减少${parseInt(data.maxHunger / 10)}`)
            return true;
        },
        text : '攻击力提高饥饿上限/5，防御力降低饥饿上限/10，每场战斗只能使用一次'
    }),
    '技能石：自食' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自食')){
                return false;
            }
            if(!inBattle()){
                winMsg('只能在战斗中使用，请丢弃该技能石重新制造', false, false)
                return false;
            }
            if(data.battleMonster.zs){
                winMsg('你已经吃过自己了', false, false)
                return false;
            }

            data.battleMonster.zs = true;
            const num = parseInt(data.maxHp * 0.2);
            if(data.hp < num){
                winMsg('生命值不足', false, false);
                return false;
            }

            data.hp -= num;
            const number = parseInt(num / 3);
            data.maxHunger += number * 2;
            addObjHunger(data, number);

            addBattleLog('你吃了自己的肉！');
            return true;
        },
        text : '食人魔实在太饿了，于是选择吃自己的肉。消耗20%生命值，每消耗3生命值，恢复1点饥饿值，增加2点饥饿值上限,每场战斗只能使用一次'
    }),
    '技能石：无尽暴食' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('无尽暴食')){
                return false;
            }

            if(data.hunger <= 0){
                winMsg('饥饿值不足', false, false);
                return false;
            }

            if(inBattle()){
                data.maxHunger += data.hunger;
            }
            battleAddHp(data, data.hunger * 2);
            data.hunger = 0;

            return true;
        },
        myHp(){
            if(!checkRace('无尽暴食')){
                return 0;
            }
            return data.hunger * 2;
        },
        text : '食人魔-暴食种族技能，为什么越吃越饿了呢。消耗所有饥饿值，每消耗1饥饿值，恢复2点生命值。如果在战斗中使用，则饥饿上限增加消耗的饥饿数'
    }),
    '技能石：铁血' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('铁血')){
                return false;
            }
            if(data.battleMonster.tx){
                winMsg('你已经是铁血状态了', false, false)
                return false;
            }

            data.battleMonster.tx = true;
            if(!data.suck){
                data.suck = 0;
            }
            data.suck += (data.weapon && data.weapon.suck ? data.weapon.suck : 0) + (data.armor && data.armor.suck ? data.armor.suck : 0) + (data.suck || 0);

            addBattleLog('你进入了铁血状态');
            return true;
        },
        text : '食人魔-暴君种族技能，进入了铁血状态，吸血翻倍，每场战斗只能使用一次'
    }),
    '技能石：爆轰术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        getAtkNum : function(){
            return getStatuNum(data, '狂热') + 1;
        },
        preFunc : function(weapon){
            if(!checkRace('爆轰术', true)){
                return false;
            }

            const need = parseInt(data.level / 5);
            if(data.hunger < need){
                winMsg('你的饥饿值不足', false, false)
                return;
            }
            data.hunger -= need;

            //获取伤害
            let harm = this.myAtk();

            if(data.race.name === '食人魔-血法师'){
                data.battleMonster.maxHp -= parseInt(harm * 0.2);
                addObjHp(data.battleMonster, 0)
            }
            return true;
        },
        atkAfter(){
            if(getStatuNum(data, '狂热') < 3){
                addStatus(data, getStatus('狂热'))
            }
        },
        myAtk : function(){
            if(!checkRace('爆轰术')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) + (data.level * 10))
        },
        text : '食人魔-双头法师种族技能，消耗相当于你等级/5的饥饿，额外造成消耗的等级*10的额外的伤害，并给自己附加一层狂热状态（最多3层）。每有一层狂热状态，该技能额外攻击一次。本技能无法触发吸血。'
    }),

    //操脑蛛技能
    '技能石：解除操纵' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('解除操纵')){
                return false;
            }
            if(!data.control){
                winMsg('你没有控制怪物', false, false)
                return false;
            }
            winMsg(`你解除了${data.control.showName || data.control.name}的控制`);
            data.control = null;
            const hp = data.hp;
            initAttr();
            data.suck = 0;
            if(data.hp > hp){
                data.hp = hp;
            }
            return true;
        },
        text : '操脑蛛种族技能，解除当前控制的怪物，并自动进行一次洗点。如果解除操纵前的血量低于洗点后的血量，则血量保持为解除操纵前的血量'
    }),
    '技能石：精神狂暴' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('精神狂暴')){
                return false;
            }
            if(data.battleMonster.jskb){
                winMsg(`你操控的${data.control.showName || data.control.name}已经处于精神狂暴当中`, false, false);
                return false;
            }
            data.battleMonster.jskb = true;

            data.atk += data.control.atk * 3;
            const old = data.control.hp;
            data.control.maxHp = data.control.hp = parseInt(data.control.hp * 0.7)
            const num = old - data.control.hp;
            data.maxHp -= num;
            data.selfAttrs.maxHp -= num;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }

            addBattleLog(`你强制让你操控的${data.control.showName || data.control.name}陷入了狂暴中`);
            return true;
        },
        text : '操脑蛛种族技能，永久降低被控制怪物30%的生命上限，并将减少的具体数值立刻体现到人物当前的生命值上限，提高控制怪物本身攻击力*3的攻击力。该技能每场战斗只能使用一次'
    }),
    '技能石：怪物强化' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('怪物强化')){
                return false;
            }
            if(!data.control.upNum){
                data.control.upNum = 0;
            }
            const need = 5 * Math.pow(2, data.control.upNum)
            const items = monsterCfgs[data.control.name].items.filter(e => elementCfgs[e.name].fromMonster).map(e => e.name);

            if(items.length === 0){
                winMsg('该怪物没有可强化的材料，无法强化', false, false)
                return;
            }

            if(items.filter(e => getNumByBag(e, data.location.join() === data.world.home.location.join()) >= need).length === items.length){
                items.forEach(e => {
                    //如果是在家，允许使用仓库中的物品
                    if(data.location.join() === data.world.home.location.join()){
                        //获取背包中的数量
                        const bagNum = getNumByBag(e);
                        //优先使用背包中的物品
                        if(bagNum >= need){
                            reduceItem(e, need);
                        }else{
                            if(bagNum > 0){
                                reduceItem(e, bagNum);
                            }
                            reduceItemByStore(e, need - bagNum);
                        }
                    }else{
                        reduceItem(e, need);
                    }
                })
                data.control.upNum++;

                data.control.hp = Math.ceil(data.control.hp * 1.1)
                data.control.atk = Math.ceil(data.control.atk * 1.1)
                data.control.def = Math.ceil(data.control.def * 1.1)

                const hp = data.hp;
                initAttr();
                if(data.hp > hp){
                    data.hp = hp;
                }
                winMsg(`强化成功，消耗[${items.join('，')}]*${need}`)
                return true;
            }else{
                winMsg(`材料不足，此次强化需要[${items.map(e => `${e}*${need}/${getNumByBag(e, data.location.join() === data.world.home.location.join())}`).join('，')}]`)
                return false;
            }
        },
        text : '强化你操纵的怪物的属性，可以无限次数强化，每次强化都会在当前属性上提高10%的血量、攻击和防御(全部向上取整)，并自动进行一次洗点，但是当前血量保持强化前的状态。强化需要消耗操纵的怪物掉落的材料（放在仓库里也可以，不用带在身上），初次强化需要消耗掉落的材料各5个，之后每强化过一次，材料翻倍。即第二次10个，第三次20个，第四次40个。取消操纵时强化获得的属性一并丢失'
    }),

    //污染者技能
    '技能石：自我扭曲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自我扭曲', true)){
                return false;
            }
            const num = ndx(5, 4) * (getStatuNum(data, '扭曲形态') + 1)

            if(data.san < num){
                addBattleLog('你试图让自己更加扭曲，但是你的理智不足以控制你的身体');
                return true;
            }

            reduceObjSan(data, num);
            addStatus(data, getStatus('扭曲形态'))

            let attrNum = getStatuNum(data, '扭曲形态') * getCthulhuScholarship();
            const attrs = ['atk','atk','atk','atk','def','def','def','hp','hp','suck'];
            //以下为一次增加获得的点数
            const addNum = {
                atk : 1,
                def : 1,
                hp : parseInt(data.maxHp * 0.01),
                suck : 1,
            }
            if(addNum.hp < 1){addNum.hp = 1}

            for(let i = 0 ; i < attrNum ; i++){
                const attr = attrs.getRandom();
                if(attr === 'suck' && !data.suck){
                    data.suck = 0;
                }
                data[attr] += addNum[attr];
                if(attr === 'hp'){
                    data.maxHp += addNum[attr];
                }
            }

            addBattleLog(`你消耗了${num}理智，并且变得更加扭曲了`)
            return true;
        },
        text : '污染者种族技能，消耗“5d4*(扭曲形态层数+1)”的理智值(当理智不足时会使用失败，并浪费这一回合的行动机会。如果理智正好和需要消耗的理智相同，消耗后会保留1点，而不是变为0)，给自己附加一层扭曲形态，并获得当前扭曲形态层数*克苏鲁学识的随机属性点，这些属性点将自动随机分配，可能分配到以下属性中：攻击（40%概率，1属性点=1攻击）/防御（30%概率，1属性点=1防御）/血量（20%概率，1属性点=1%血量，最少1）/吸血（10%概率，1属性点=1%吸血）'
    }),
    '技能石：无智狂暴' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('无智狂暴', true)){
                return false;
            }

            if(data.san > 10){
                reduceObjSan(data, 10);
                data.atkSpd += 1;
            }else{
                winMsg('理智不足', false, false)
                return false;
            }

            addBattleLog(`你失去了10理智，获得1点攻速加成`)
            return true;
        },
        text : '污染者种族技能，消耗10点理智，获得1点攻速加成'
    }),

    //星灵系技能
    '技能石：时间穿梭' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('时间穿梭', true)){
                return false;
            }
            $('.item-use-win-modal').hide();
            $('.item-use-win').hide();
            $('.win').hide();
            $('.time-shuttle').show();
            return true;
        }, text : '星灵种族技能，可以穿梭到未来，具体穿梭到多久后的未来可以自行选择'
    }),

    //精灵系列技能
    '技能石：自然附着' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('自然附着', true)){
                return false;
            }
            renderNaturalAttachment();
            $('.natural-attachment').show();
            return true;
        },
        text : '精灵种族技能，可将非弓类武器的属性附着在弓胚上，附着后，弓胚将获得附着武器的攻击、防御、减伤、吸血、血量、等级、孔数、镶嵌物、品质、名字。'
    }),
    '技能石：木箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 1,
        endurance : 30,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('木箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：魔法箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 5,
        endurance : 30,
        level : 5,
        weight : 2,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('魔法箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：火焰箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 5,
        quality : 1,
        level : 10,
        endurance : 30,
        weight : 2,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('火焰箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        atkAfter(){
            addStatus(data.battleMonster, getStatus('燃烧', {harm : 50}));
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '命中敌方后，给敌方附加燃烧状态，每回合造成50伤害，持续3回合。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：腐蚀箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 10,
        quality : 2,
        level : 40,
        endurance : 30,
        weight : 1,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('腐蚀箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        atkAfter(){
            data.battleMonster.def -= 10;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '命中敌方后，减少敌方10点防御。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：穿甲箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 1,
        quality : 2,
        level : 50,
        endurance : 30,
        weight : 3,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('穿甲箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, true);
        },
        text : '无视防御。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：爆裂箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 5,
        quality : 2,
        level : 50,
        endurance : 30,
        weight : 2,
        voidDust : 0,
        gold : 0,
        atkNum : 5,
        preFunc : function(weapon) {
            if (!checkRace('爆裂箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, false, 0.35);
        },
        text : '造成5次35%的伤害。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：变身巨熊' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('变身巨熊', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('巨熊形态'))

            data.reduceHart += 0.1;
            let addDef = parseInt(data.def * 0.3)
            if(addDef < 200){
                addDef = 200;
            }
            data.reduceHart += 0.1;
            data.def += addDef;
            data.maxHp *= 2;

            addBattleLog(`你变身为了巨熊形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为巨熊形态，增加10%减伤，防御力增加30%（至少200），生命上限增加100%。每场战斗只能变身一次'
    }),
    '技能石：变身猎豹' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('变身猎豹', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('猎豹形态'))

            data.atk *= 2;
            data.def = parseInt(data.def / 2)
            data.maxHp = parseInt(data.maxHp / 2)
            addObjHp(data, 0);

            addBattleLog(`你变身为了猎豹形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为猎豹形态，增加攻击力翻倍，防御力和生命上限减半。每场战斗只能变身一次'
    }),
    '技能石：撼地击' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('撼地击', true)) {
                return false;
            }
            if (!getStatuNum(data, '巨熊形态')) {
                winMsg(`只能在变身为巨熊形态时使用`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, false, 0.8);
        },
        atkAfter(){
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('眩晕'))
            }
        },
        text : '精灵-德鲁伊种族技能，只能在变身为巨熊形态时使用。造成80%的伤害，并有30%几率眩晕敌方一回合'
    }),
    '技能石：双爪撕裂' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        atkNum : 2,
        preFunc : function(weapon) {
            if (!checkRace('双爪撕裂', true)) {
                return false;
            }
            if (!getStatuNum(data, '猎豹形态')) {
                winMsg(`只能在变身为猎豹形态时使用`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, false, 0.7);
        },
        atkAfter(){
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('流血', {harm : data.level * 4}))
            }
        },
        text : '精灵-德鲁伊种族技能，只能在变身为猎豹形态时使用。造成两次70%的伤害，并有30%几率使敌方陷入流血状态，每回合造成玩家等级*4的伤害，持续3回合'
    }),
    '技能石：大地之熊' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('大地之熊', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('巨熊形态'))

            data.reduceHart += 0.2;
            let addDef = data.def
            if(addDef < 500){
                addDef = 500;
            }
            data.reduceHart += 0.1;
            data.def += addDef;
            data.maxHp *= 3;

            addBattleLog(`你变身为了巨熊形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为大地之熊形态（本质上依旧是巨熊形态），增加20%减伤，防御力增加100%（至少500），生命上限增加200%。每场战斗只能变身一次'
    }),
    '技能石：幻影猎豹' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('幻影猎豹', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('猎豹形态'))

            data.atk = parseInt(data.atk * 2.5);
            addObjHp(data, 0);

            addBattleLog(`你变身为了猎豹形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为幻影猎豹形态（本质上依旧是猎豹形态），增加攻击力增加150%。每场战斗只能变身一次'
    }),

    //半人马系列技能
    '技能石：冲锋' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        getAtkNum : function(){
            if(data.race.name === '半人马-轻骑兵'){
                if(data.spd < 100){
                    if(randomNum() <= 20){
                        return 2;
                    }
                }else if(data.spd < 199){
                    if(randomNum() <= 40){
                        return 2;
                    }
                }else{
                    if(randomNum() <= 60){
                        return 2;
                    }
                }
            }
            return 1;
        },
        preFunc : function(weapon) {
            if (!checkRace('冲锋', true)) {
                return false;
            }
            return true;
        },
        myAtk : function(item){
            let dd = false;
            let rate = 1;
            let otherAtk = 0;

            if(data.spd < 100){
                dd = randomNum() <= 10;
                rate += data.spd * 0.02;
                if(data.race.name === '半人马-重骑兵'){
                    otherAtk = parseInt(data.def / 2);
                }
            }else if(data.spd < 199){
                dd = randomNum() <= 30;
                rate += randomNum(data.spd * 2, data.spd * 3) / 100;
                if(data.race.name === '半人马-重骑兵'){
                    otherAtk = data.def;
                }
            }else{
                dd = true;
                rate += randomNum(data.spd * 2, data.spd * 4) / 100;
                if(data.race.name === '半人马-重骑兵'){
                    otherAtk = data.def * 2;
                }
            }

            if(data.race.name === '半人马-西凉铁骑'){
                otherAtk = data.def * 3;
                dd = true;
            }

            return getBaseAtk(otherAtk, true, true, dd, parseFloat2Fiexd(rate));
        },
        atkAfter(){
            if(data.spd < 100){
                if(randomNum(1,100) <= 10){
                    addStatus(data.battleMonster, getStatus('反应不及'))
                }
                addStatus(data, getStatus('减速', { num : 1}))

            }else if(data.spd < 199){
                if(randomNum(1,100) <= 30){
                    addStatus(data.battleMonster, getStatus('反应不及'))
                }
                addStatus(data, getStatus('减速', { num : 2}))

            }else{
                if(randomNum(1,100) <= 50){
                    addStatus(data.battleMonster, getStatus('反应不及'))
                }
                addStatus(data, getStatus('减速', { num : 3}))
            }
            if(getStatuNum(data, '提速') >= 5){
                addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
            }
            data.spd -= getStatuNum(data, '提速') * 15
            removeStatus(data, '提速')
        },
        text : '半人马种族技能，冲锋后陷入减速状态，无法行动，并有几率给对方附加反应不及状态，使其无法行动，持续1回合。速度加成在1%~99%时，每有1%速度加成，增加2%伤害，有10%概率无视防御，减速状态持续1回合，附加反应不及状态的概率为10%；速度加成在100%~199%时，每有1%速度加成，增加随机2%~3%伤害，有30%概率无视防御，减速状态持续2回合，附加反应不及状态的概率为30%；速度大于等于200%时，每有1%速度加成，增加随机2%~4%伤害，无视防御，减速状态持续3回合，附加反应不及状态的概率为50%；'
    }),
    '技能石：神速' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('神速', true)){
                return false;
            }

            if(getStatuNum(data, '神速')){
                winMsg(`你已经是神速状态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('神速'))
            data.spd += 500;
            addBattleLog(`你使用了神速，速度增加500%，命中率降低30%`)
            return true;
        },
        text : '半人马-白马义从种族技能，给自己附加神速状态，速度提高500%，命中降低30%'
    }),
    '技能石：解除神速' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('解除神速', true)){
                return false;
            }

            if(!getStatuNum(data, '神速')){
                winMsg(`你并不是神速状态`, false, false);
                return false;
            }

            removeStatus(data, '神速')
            data.spd -= 5000;
            addBattleLog(`你解除了神速状态`)
            return true;
        },
        text : '半人马-白马义从种族技能，解除神速状态'
    }),
    '技能石：提速' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('提速', true)){
                return false;
            }

            if(getStatuNum(data, '提速') >= 5){
                winMsg(`你已经是全速前进了`, false, false);
                return false;
            }

            addStatus(data, getStatus('提速'))
            data.spd += 15;
            addBattleLog(`你使用了提速，速度增加15%`)
            return true;
        },
        text : '半人马-重骑兵种族技能，给自己附加提速状态，每有1层提速状态，速度提高15%，最高5层。使用冲锋后消除提速状态。在提速状态为5层时使用冲锋时，100%让对方眩晕3回合。'
    }),

    /*地精系技能*/
    '技能石：埋雷' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('埋雷')){
                return false;
            }

            let ts = data.bag.filter(e => e.name.endsWith('炸药'));
            if(ts.length){
                $('.select-explosive-win').show().find('.select-explosive-win-items').html(`${ts.map(e => `<div data-id="${e.id}">${e.showName || e.name}*${e.quantity}</div>`).join('')}`);
            }else{
                winMsg(`你背包中没有炸药`, false, false);
                return false;
            }

            return true;
        },
        text : '地精种族技能，在当前位置埋下指定类型、指定数量的炸药。每次时间流逝，都有可能被游荡的怪物无意间引爆炸药，每埋藏了1个炸药，引爆概率增加1%。怪物无意间引爆炸药会导致你埋藏的炸药全部被白白触发，你无法获得任何收获'
    }),
    '技能石：引诱' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('引诱', true)){
                return false;
            }

            if(data.buryExplosive[data.world.name] && data.buryExplosive[data.world.name][data.location.join()]) {
                let explosives = data.buryExplosive[data.world.name][data.location.join()];
                let names = Object.keys(explosives);
                if(names.length){
                    let harm = 0;
                    names.forEach(e => {
                        harm += elementCfgs[e].atk * explosives[e];
                    })

                    if(harm > 0){
                        harm = randomNum(parseInt(harm * 0.3), parseInt(harm * 0.6));
                        data.buryExplosive[data.world.name][data.location.join()] = {};

                        data.battleMonster.hp -= reduceShield(data.battleMonster, harm);
                        addBattleLog(`你引爆了埋藏的炸药，${data.battleMonster.showName || data.battleMonster.name}受到了${harm}伤害`)
                        if(harm >= parseInt(data.battleMonster.maxHp * 0.5)){
                            addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
                        }
                        if(data.battleMonster.hp <= 0){
                            battleWin();
                        }
                    }else{
                        winMsg(`这里没有埋藏炸药或炸药总伤害小于等于0`, false, false);
                        return false;
                    }
                }else{
                    winMsg(`这里没有埋藏炸药`, false, false);
                    return false;
                }
            }else{
                winMsg(`这里没有埋藏炸药`, false, false);
                return false;
            }

            return true;
        },
        text : '地精种族技能，如果当前位置埋了火药，则可以将敌方引诱到火药埋藏点，并引爆火药。本技能会一次性引爆埋下的所有火药，并造成埋下火药本身威力的30%~60%的伤害，本伤害不会再进行20%的随机波动。如果本次伤害让怪物降低了一半以上血量（不是降低到一半以下，是造成的伤害达到怪物血量上限的一半，被怪物护盾抵挡的伤害不算在内），则眩晕怪物3回合。'
    }),
    '技能石：启动备用模式' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if(!data.mount || !data.mount.name.endsWith('伐木机器人')){
                winMsg('必须驾驶伐木机器人时才能使用', false, false)
                return false;
            }
            return true;
        },
        myAtk : function(){
            return data.mount ? data.mount.endurance : 0;
        },
        atkAfter(){
            const mount = data.mount;
            addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
            battleOtherAtk(parseInt(data.mount.endurance * 0.2), data, false);
            equipMount(mount);
            reduceItemById(mount.id);
        },
        text : '仅限驾驶伐木机器人时使用。地精们管这叫备用模式，而在大家看来，这就是单纯地自爆而已（说好的爆炸救不了地精呢？）。自爆当前驾驶的机器人，造成机器人当前耐久度*1的伤害，并使敌方眩晕3回合。并对你造成机器人当前耐久度*0.2的伤害(不进行波动，该伤害可被你的减伤和防御减免)'
    }),
    '技能石：地精万岁' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if(!data.mount || !data.mount.name.endsWith('载弹机器人')){
                winMsg('必须驾驶载弹机器人时才能使用', false, false)
                return false;
            }
            if(!data.mount.yzd){
                winMsg('你驾驶的载弹机器人未装弹', false, false)
                return false;
            }
            return true;
        },
        myAtk : function(){
            return 10000000;
        },
        atkAfter(){
            const mount = data.mount;
            const harm = battleOtherAtk(10000000, data, false);
            equipMount(mount);
            reduceItemById(mount.id);
            addBattleLog(`你受到了会裂开的炸药造成的${harm}伤害`)
            //触发地精万岁的核爆
            nuclearExplosion();
        },
        text : '仅限驾驶载弹机器人，且已装弹时使用。对敌方和自身都造成1000万伤害（防御和减伤可以减免该伤害，虽然没什么意义），且摧毁以当前地图为中心的两格之内的所有地形(即5*5范围，总共25格地形)，将其变为废土，该范围内所有NPC和游荡的神话都会死亡，神殿将被摧毁（不会扣除你的神眷），你的家如果在这一范围内也会被摧毁，仓库物品全部丢失。地图出入口不会受到影响，守关BOSS不受影响，别管为什么，问就是作者之力。'
    }),
    '技能石：装弹' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!data.mount || !data.mount.name.endsWith('载弹机器人')){
                winMsg('必须驾驶载弹机器人时才能使用', false, false)
                return false;
            }
            if(data.mount.yzd){
                winMsg('你驾驶的载弹机器人已装弹', false, false)
                return false;
            }

            let ts = data.bag.filter(e => e.name === '会裂开的炸药');
            if(ts.length){
                let bagItemById = getBagItemById(data.mount.id);
                bagItemById.yzd = true;
                bagItemById.showName = `载弹机器人-已装弹`
                data.mount = bagItemById;
                reduceItem('会裂开的炸药')
                winMsg('装弹完成', false, false)
            }else{
                winMsg(`你背包中没有会裂开的炸药`, false, false);
                return false;
            }

            return true;
        },
        text : '仅限驾驶载弹机器人，且未装弹时使用。将背包中的一个“会裂开的炸药”装在到载弹机器人上面。'
    }),
    '技能石：卸弹' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!data.mount || !data.mount.name.endsWith('载弹机器人')){
                winMsg('必须驾驶载弹机器人时才能使用', false, false)
                return false;
            }
            if(!data.mount.yzd){
                winMsg('你驾驶的载弹机器人未装弹', false, false)
                return false;
            }

            let bagItemById = getBagItemById(data.mount.id);
            bagItemById.yzd = false;
            bagItemById.showName = null
            data.mount = bagItemById;
            addItem('会裂开的炸药')
            winMsg('卸弹完成', false, false)
            return true;
        },
        text : '仅限驾驶载弹机器人，且已装弹时使用。将“会裂开的炸药”从载弹机器人上面卸下。'
    }),

    //狐族系技能
    '技能石：吓唬' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('吓唬', true)){
                return false;
            }
            if(data.battleMonster.xh){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.xh = true;
            if(!data.battleMonster.type && randomNum() <= (100 - (data.battleMonster.level * 3))){
                msg('对方被你吓走了');
                battleEnd();
                setTimeout(function(){timeLapses(battleRunMin);},100)
            }else{
                data.battleMonster.atk += parseInt(data.battleMonster.atk * 0.2)
                addBattleLog('对方没有被你吓住，反而激发了凶性，攻击力提高20%')
            }

            return true;
        },
        text : '狐族种族技能，变成可怕的怪物吓唬敌人，如果吓唬成功，敌人会直接逃跑，结束战斗，但是你无法获得经验和战利品。对普通怪物使用才有可能成功，对精英及以上的怪物使用也允许使用，但是必定会失败。敌人每有1级，成功率降低3%，所以对33级以上的怪物使用一定会失败。如果吓唬失败，敌人会被激发凶性，其攻击力将提高20%。'
    }),
    '技能石：狐火' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('狐火', true)) {
                return false;
            }
            const need = 10;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(data.battleMonster ? parseInt(data.battleMonster.def * 0.5) : 0, true, true, false, 1.2);
        },
        text : '狐族-狐妖种族技能，消耗10饥饿和10水分，对敌方造成1.2倍伤害，并无视50%的防御。该技能无法吸血'
    }),
    '技能石：唤灵' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('唤灵', true)) {
                return false;
            }
            const need = 50;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, true, 2);
        },
        text : '狐族-狐妖种族技能，消耗50饥饿和50水分，对敌方造成2倍伤害，无视防御。该技能无法吸血'
    }),
    '技能石：迷魂' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('迷魂', true)) {
                return false;
            }
            const need = 200;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            data.safeRun = true;
            return true;
        },
        text : '狐族-狐妖种族技能，消耗200饥饿和200水分，使用后不会被怪物主动攻击，当进行采集或者触发战斗时失效'
    }),
    '技能石：呼风' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('呼风', true)){
                return false;
            }
            const need = 100;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            if(data.battleMonster.hf){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            data.battleMonster.hf = true;

            let def = parseInt(data.battleMonster.def * 0.5);
            if(def < 0){
                def = 0;
            }
            data.battleMonster.def -= def;
            addStatus(data.battleMonster, getStatus('烈风', {harm : def}))
            addBattleLog(`风来！`)

            return true;
        },
        text : '狐族-狐仙种族技能，消耗100饥饿和100水分，将对方防御减半，并给对方附加烈风状态，每回合造成对方因本技能减少的防御力的伤害，该状态不会自动消失。该技能每场战斗只能使用一次'
    }),
    '技能石：唤雨' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        atkNum : 10,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('唤雨', true)) {
                return false;
            }
            const need = 20;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(data.level, true, true, false, 0.5);
        },
        atkAfter(){
            if(hasStatus(data.battleMonster,'烈风')){
                removeStatus(data.battleMonster,'烈风');
                addStatus(data.battleMonster, getStatus('风雨交加', {harm : data.battleMonster.def * 2}))
            }
        },
        text : '狐族-狐仙种族技能，消耗20饥饿和20水分，对敌方造成10次0.5倍+你当前等级的伤害。如果对方有烈风状态，则清除对方的烈风状态，给对方附加“风雨交加”状态，每回合造成对方剩余防御力*2的伤害，该状态不会自动消失，该技能无法吸血'
    }),
    '技能石：招雷' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('招雷', true)) {
                return false;
            }
            const need = 500;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            if(!hasStatus(data.battleMonster,'风雨交加')){
                winMsg('你应当先呼风唤雨，方能招雷', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, false, 1 + (data.battleMonster ? parseInt((data.battleMonster.maxHp - data.battleMonster.hp) / data.battleMonster.maxHp * 100) : 0));
        },
        text : '狐族-狐仙种族技能，当对方有风雨交加状态时才能使用。消耗500饥饿和500水分，对敌方造成特定倍数的伤害。基础为1倍，对方每损失1%血量，伤害增加1倍。该技能无法吸血'
    }),

    //魅魔系技能

    //魅魔系技能
    '技能石：魅惑' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('魅惑', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg('不能在副本中使用', false, false);
                return false;
            }

            if(data.battleMonster.type && data.race.name === '魅魔'){
                winMsg('只能对普通怪物使用', false, false)
                return false;
            }
            if((data.battleMonster.type === '传说' || data.battleMonster.type === '神话') && data.race.name === '魅魔-首领'){
                winMsg('只能对普通和精英怪物使用', false, false)
                return false;
            }
            if(data.battleMonster.type === '神话' && data.race.name === '魅魔-女王'){
                winMsg('不能对神话怪物使用', false, false)
                return false;
            }
            if(randomNum() <= (data.level - data.battleMonster.level - 10)){
                winMsg(`你吸收了${data.battleMonster.name}的精气`);

                let ts = data.blood.filter(e => e.name === data.battleMonster.name);
                if(ts.length){
                    ts[0].num++;
                }else{
                    data.blood.push({
                        name : data.battleMonster.name,
                        num : 10
                    });
                }

                data.level -= data.battleMonster.level;
                data.exp = 0;
                if(data.weapon && data.weapon.level > data.level){
                    equip(data.weapon)
                }
                if(data.armor && data.armor.level > data.level){
                    equip(data.armor)
                }
                battleEnd();
                setTimeout(() => {
                    timeLapses(battleWinMin);
                }, 10)
                initAttr();
            }else{
                addBattleLog('吸收失败')
            }
            return true;
        },
        text : '魅魔种族技能，魅惑敌方，如果成功，则吸收对方的精气，并结束战斗，不会获得战斗奖励。魅惑成功率为：你的等级-对方等级-10，即你至少要高出对方11级，才有可能魅惑成功。该技能不能在副本中使用，且只能对普通怪物使用'
    }),
    '技能石：查看气息' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('查看气息', true)){
                return false;
            }
            seeBlood();
            return true;
        },
        text : '魅魔种族技能，查看自身拥有的气息'
    }),

    //断肠人系技能
    '技能石：悲怨' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('悲怨', true)) {
                return false;
            }
            if(data.soulName !== '泷'){
                winMsg('我应当没有这个能力才是，但……好熟悉', false, false)
                return false;
            }
            if(data.san <= 2){
                winMsg('你的理智不足',false,false)
                return false;
            }
            reduceObjSan(data, 2);
            return true;
        },
        atkAfter(){
            addBattleLog(data.race.says[data.soulName].getRandom());
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, false, 1 + ((data.maxSan - data.san) * 0.05));
        },
        text : '断肠人种族技能，只有泷才能使用。消耗2点理智，对敌方造成基础为1倍的伤害。当前理智每比理智上限低1点，伤害增加0.05倍。'
    }),
    '技能石：痴念' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('痴念', true)) {
                return false;
            }
            if(data.soulName !== '鸳'){
                winMsg('鸳……我好想你', false, false)
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }

            reduceObjSan(data, 1);
            data.reduceHart += 0.15;
            data.cnReduceHart += 0.15;

            addBattleLog(data.race.says[data.soulName].getRandom());
            return true;
        },
        text : '断肠人种族技能，只有鸳才能使用。消耗1点理智，增加3%减伤，可无限叠加。使用该技能时，你的该技能增加的减伤在切换灵魂时会全部失去。'
    }),
    '技能石：癫狂' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        atkNum : 5,
        preFunc : function(weapon) {
            if (!checkRace('癫狂', true)) {
                return false;
            }
            if(!getStatuNum(data, '心悸')){
                winMsg('你心如死灰', false, false)
                return false;
            }
            return true;
        },
        atkAfter(){
            addBattleLog(data.soulName === '泷' ? '鸳!你在对吗，是你吗鸳？' : '泷，泷！你在哪里？泷！');
            removeStatus(data, '心悸')
            if(data.selfAttrs){
                data.def -= parseInt(data.selfAttrs.def * (data.maxSan - data.san) * 0.02)
            }
            data.san = data.maxSan;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, true, (data.maxSan - data.san) * 0.1);
        },
        text : '断肠人种族技能，泷和鸳都能使用，拥有“心悸”状态时才能使用。一瞬间的心悸，你似乎感觉到恋人的存在，似乎你们从未分开过，你不管不顾，只想找到对方。补满理智值，造成5次0倍(即初始无伤害)无视防御的伤害，每因为该技能恢复1点理智，则伤害倍数增加0.1倍，每因为该技能恢复1点理智，防御降低2%（以战斗开始时的防御计算，多次使用该技能可以让自身防御变为负数）。该技能无法吸血'
    }),
    '技能石：肝肠寸断' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('肝肠寸断', true)) {
                return false;
            }
            if(data.level < 60){
                winMsg('至少60级才可以使用！', false, false);
                return false;
            }
            winMsg(`枯藤老树昏鸦，小桥流水人家，古道西风瘦马，夕阳西下，断肠人在天涯`);
            checkRaceOnceAwaken(data.soulName === '泷' ? '断肠人-独竹' : '断肠人-孤芳');
            return true;
        },
        text : '断肠人种族技能，60级以上才能使用。泷使用该技能将觉醒为“断肠人-独竹”，鸳使用该技能将觉醒为“断肠人-孤芳”，等级回到60级，已有的经验依旧保持不变，并自动进行一次洗点'
    }),
    '技能石：万年霜雪' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('万年霜雪', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            if(data.battleMonster.wnsx){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            data.battleMonster.wnsx = true;
            reduceObjSan(data, 1);
            addStatus(data.battleMonster, getStatus('万年霜雪', {harm : parseInt(data.atk * (data.maxSan - data.san) * 0.1)}))
            let num = parseInt((data.maxSan - data.san) / 5);
            if(num > 0){
                addStatus(data.battleMonster, getStatus('冰冻', {num}))
            }
            return true;
        },
        text : '断肠人-孤芳种族技能，消耗1点理智，给对方附加万年霜雪状态，每回合造成X(基础倍率为0，当前理智每比最高理智少1点，倍率增加0.1)倍攻击力的伤害，该状态不会自动消失。同时当前理智每比最高理智少5点，则冰冻（使对方无法行动）对方1回合。该技能每场战斗只能使用一次'
    }),
    '技能石：残花落尽' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('残花落尽', true)) {
                return false;
            }
            if(data.san <= 10){
                winMsg('你的理智不足',false,false)
                return false;
            }
            if(data.battleMonster.chlj){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            data.battleMonster.chlj = true;
            reduceObjSan(data, 10);
            addStatus(data, getStatus('冷静'))
            return true;
        },
        text : '断肠人-孤芳种族技能，消耗10点理智，给自己附加“冷静”状态，使自己不会因为理智原因陷入疯狂，持续10回合。该技能每场战斗只能使用一次'
    }),
    '技能石：疯魔' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        getAtkNum : function(){
            return data.san - 1;
        },
        preFunc : function(weapon) {
            if (!checkRace('疯魔', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, true, 1);
        },
        atkAfter(){
            data.san = 1;
        },
        text : '断肠人-红煞种族技能，消耗所有理智，只保留1点，消耗了多少理智，就造成多少次1倍攻击且无视防御的伤害'
    }),
    '技能石：心茫然' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('心茫然', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            reduceObjSan(data, 1);
            let addHp = this.myHp();
            const text = `你使用了心茫然，恢复${battleAddHp(data, addHp)}HP`;
            addStatus(data.battleMonster, getStatus('茫然'))
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return parseInt(data.maxHp * 0.1);
        },
        text : '断肠人-独竹种族技能，消耗1点理智，恢复10%生命值，并给对方附加茫然状态，使其无法行动，持续1回合'
    }),
    '技能石：崩灵' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('崩灵', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            addStatus(data.battleMonster, getStatus('茫然', {num : data.san - 1}))
            data.san = 1;
            return true;
        },
        text : '断肠人-黑邪种族技能，消耗所有理智，只保留1点，消耗了多少理智，就给对方附加多少回合的茫然状态，使其无法行动'
    }),
    '技能石：风月情浓' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('风月情浓', true)){
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            if(inBattle() && data.battleMonster.fyqn){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            reduceObjSan(data, 1);
            if(inBattle()){
                data.battleMonster.fyqn = true;
                battleAddHp(data, this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            }else{
                this.hp = this.maxHp;
            }

            const text = `使用了风月情浓，生命值完全恢复`;
            msg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '断肠人-花魂种族技能，消耗1点理智，恢复全部生命值'
    }),
    '技能石：死生契阔' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        atkNum : 2,
        preFunc : function(weapon) {
            if (!checkRace('死生契阔', true)) {
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, false, 1 + ((data.maxSan - data.san) * 0.01));
        },
        text : '断肠人-花魂种族技能，造成2次伤害，当前理智每比理智上限低1点，伤害增加1%'
    }),

    //天使系技能
    '技能石：混沌审判' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('混沌审判', true)) {
                return false;
            }
            if(data.evil < 10 && data.evil > -10){
                winMsg('你的善良值/邪恶值不足',false,false)
                return false;
            }

            //善良阵营使用
            if(data.evil < 0){
                if(hasStatus(data, '不灭')){
                    winMsg('你已经拥有不灭状态',false,false)
                    return false;
                }
                //这里因为是固定-10善良，所以不调用addEvil
                addStatus(data, getStatus('不灭'))
                addBattleLog(`你使用了混沌审判，获得了不灭状态`)
            }else{//邪恶阵营使用
                if(hasStatus(data, '杀欲')){
                    winMsg('你已经拥有杀欲状态',false,false)
                    return false;
                }
                //这里因为是固定-10邪恶，所以不调用addEvil
                data.atk += data.level * 3;
                addBattleLog(`你使用了混沌审判，获得了${data.level * 3}攻击力`)
                addStatus(data, getStatus('杀欲'))
            }

            return true;
        },
        text : '天使-混沌种族技能，当前为邪恶阵营时消耗10点邪恶值，给自己附加“杀欲”状态，攻击力增加你当前等级的3倍当你失去杀欲状态时，增加的攻击力会扣除。杀欲状态每回合会消耗你10点邪恶值，当你的邪恶值足够10点时，杀欲状态不会随着回合结束自动减少层数，当你的邪恶值不足10点，则杀欲状态消失。当你为善良阵营时，消耗10点善良值，给自己附加“不灭”状态，拥有不灭状态时，如果你的生命值上限大于0，则你的生命值至少会保留1点，不会死亡。不灭状态每回合会消耗你10点善良值，当你的善良值足够10点时，不灭状态不会随着回合结束自动减少层数，当你的善良值不足10点，则不灭状态消失。'
    }),
    '技能石：阵营转换' : new Element({
        canUse : true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('阵营转换', true)) {
                return false;
            }

            if(data.evil === 0){
                winMsg('你当前为中立阵营，无法转换阵营',false,false)
                return false;
            }

            data.evil = -data.evil;
            addBattleLog(`你的阵营转为了${getPlayerCamp()}`)
            winMsg(`你的阵营转为了${getPlayerCamp()}`)

            return true;
        },
        text : '天使-伪神种族技能，不为中立阵营时才能使用。如果当前是善良阵营，善良点数变为等值的邪恶点数，阵营转为邪恶阵营。如果当前是邪恶阵，邪恶点数变为等值的善良点数，阵营转为善良阵营。'
    }),

    //魔术师系技能
    ...getBatchItem(['碎裂','裂开','完整','无瑕','完美','璀璨'], function(name){
        const level = gemNames.filter(e => e.name === `${name}的`)[0].level;

        return {
            [`技能石：宝石阵_${name}`] : new Element({
                battleUse : true,
                weight : 0,
                voidDust : 0,
                quality : 1,
                gold : 0,
                func : function(){
                    if (!checkRace(`宝石阵_${name}`, true)) {
                        return false;
                    }

                    if(hasStatus(data, `${name}阵`)){
                        winMsg(`身上没有“${name}阵”状态才能使用`,false,false)
                        return false;
                    }

                    if(data.level < level){
                        winMsg(`${level}级以上才能使用`,false,false)
                        return false;
                    }

                    //判断是否有其他宝石阵状态
                    let filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
                    //有的话，归还宝石
                    if(filter.length){
                        //获取状态名
                        const name = filter[0].name;
                        //获取宝石类型
                        let type = name.replace('阵', '');
                        //获取所有宝石状态
                        let gems = data.status.filter(e => e.name.endsWith('宝石') && e.name.length === 3);
                        //循环获取宝石，并删除状态
                        gems.forEach(e => {
                            let gemColor = e.name.replace('宝石', '');
                            if(gemColor === '橙'){
                                gemColor = '橙色';
                            }
                            addItem(`${type}的${gemColor}宝石`, e.num);
                            removeStatus(data, e.name);
                        })
                        //删除宝石阵状态
                        removeStatus(data, name);
                    }

                    addBattleLog(`你展开了${name}阵`)
                    addStatus(data, getStatus(`${name}阵`))

                    return true;
                },
                text : `魔术师种族技能，${level}级以上才能使用，身上没有“${name}阵”状态才能使用。如果身上没有其他宝石阵的状态，即可获得“${name}阵”状态。如果身上有其他宝石阵的状态，则将那个状态移除，然后将所有“X宝石”状态移除，归还用于附加“X宝石”状态所消耗的对应数量的宝石，并获得“${name}阵”状态。${name}阵状态不会自动减少`
            })
        }
    }),
    ...getBatchItem(['红','黄','紫','绿','橙'], function(name){
        return {
            [`技能石：${name}宝石镶嵌`] : new Element({
                battleUse : true,
                weight : 0,
                voidDust : 0,
                quality : 1,
                gold : 0,
                func : function(){
                    if (!checkRace(`${name}宝石镶嵌`, true)) {
                        return false;
                    }

                    if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                        winMsg(`请先设定一个宝石阵`,false,false)
                        return false;
                    }

                    //获取宝石品质
                    let type = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3)[0].name.replace('阵', '');
                    let gemColor = name === '橙' ? name + '色' : name;

                    if(!getNumByBag(`${type}的${gemColor}宝石`, data.location.join() === data.world.home.location.join())){
                        winMsg(`需要消耗1个${type}的${gemColor}宝石`,false,false);
                        return false;
                    }

                    //消耗宝石
                    reduceItemByAll(`${type}的${gemColor}宝石`)
                    //添加状态
                    addStatus(data, getStatus(`${name}宝石`))
                    addBattleLog(`你给宝石阵镶嵌了一个${name}宝石`)

                    return true;
                },
                text : `魔术师种族技能，需要先设置宝石阵才能使用。消耗1个和宝石阵对应品质的${name}宝石，给自己增加1层“${name}宝石”状态，该状态不会自动消失，可以无限累加。该技能消耗的宝石在切换宝石阵时会归还，因为状态被清除或者战斗结束时都不会归还。`
            })
        }
    }),
    '技能石：火焰魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('火焰魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({红:1,黄:1,橙:1});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:橙=1:1:1】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //添加燃烧状态
            addStatus(data.battleMonster, getStatus('燃烧', {harm : this.getAtk(this), num : getQualityBaseNum() * 2}))
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            //倍率加值
            const rate = checkGemNum({红:1,黄:1,橙:1});
            return getFinalNum(getBaseAtk(0, true, true, false, rate + 1), ['红', '黄', '橙']);
        },
        text : '魔术师种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:橙=1:1:1】，不允许镶嵌其他颜色的宝石。该魔术造成【基础伤害*(1+倍率加值)*最终效果】的伤害，并给对方附加燃烧状态，每回合都造成和等同于输出值的伤害，持续【品质基数*2】回合。该技能无法触发吸血'
    }),
    '技能石：冰霜魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('冰霜魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({紫:1,绿:1,橙:1});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【紫:绿:橙=1:1:1】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //倍率加值
            const rate = checkGemNum({紫:1,绿:1,橙:1});
            //添加冰冻状态
            addStatus(data.battleMonster, getStatus('冰冻', {num : rate * 2 + 2}))
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            return getFinalNum(getBaseAtk(0, true, true, false, getQualityBaseNum() * 0.3), ['紫', '绿', '橙']);
        },
        text : '魔术师种族技能，需要宝石阵上镶嵌宝石的比例为【紫:绿:橙=1:1:1】，不允许镶嵌其他颜色的宝石。该魔术造成【基础伤害*品质基数*0.3*最终效果】的伤害，并给对方附加冰冻状态，使敌方无法行动，持续【2 + (倍率加值*2)】回合。该技能无法触发吸血'
    }),
    '技能石：彩虹魔术' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('彩虹魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            //倍率加值
            let rate = checkGemNum({红:1,黄:1,紫:1,绿:1,橙:1});
            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=1:1:1:1:1】', false, false)
                return;
            }

            //品质基数
            let qualityBaseNum = getQualityBaseNum();
            //已有生命值
            const hp = data.hp;
            //已损失生命值
            const reduceHp = data.maxHp - data.hp;

            if(hp === reduceHp){
                winMsg('当前血量和已损失血量相同时无法使用', false, false)
                return;
            }
            if(reduceHp == 0){
                winMsg('满血时无法使用', false, false)
                return;
            }

            //回血
            if(reduceHp > hp){
                data.hp = reduceHp;
                //回血量
                const addNum = reduceHp - hp;
                //增加的护盾
                let finalNum = getFinalNum(addNum * (rate + 1), ['红','黄','紫','绿','橙']);
                data.shield += finalNum;
                addBattleLog(`你使用了彩虹魔术，恢复${battleAddHp(data, addNum)}生命值，并获得${finalNum}护盾`)
            }else{//扣血
                data.hp = data.maxHp - hp;
                //扣血量
                const reduceNum = hp - reduceHp;
                //减少的生命上限
                let finalNum = getFinalNum(reduceNum * (rate + 1) * 0.2 * qualityBaseNum, ['红','黄','紫','绿','橙']);
                data.battleMonster.maxHp -= finalNum;
                addObjHp(data.battleMonster, 0);
                addBattleLog(`你使用了彩虹魔术，损失了${reduceNum}生命值，并使${data.battleMonster.showName || data.battleMonster.name}减少了${finalNum}生命上限`)
            }

            //魔术完成
            magicOver()

            return true;
        },
        text : '魔术师-光影种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=1:1:1:1:1】。当前血量和已损失血量相同时无法使用，满血时无法使用。将自身的当前血量和已损失血量互换，每因为此效果恢复1点生命值，获得【恢复生命值*(倍率加值 + 1)*最终效果】的护盾；每因为此效果损失1点生命值，减少对方相当于【损失生命值*(倍率加值 + 1)*0.2*品质基数*最终效果】的生命上限'
    }),
    '技能石：极光魔术' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('极光魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            //倍率加值
            let rate = checkGemNum({红:35,黄:26,紫:18,绿:22,橙:21});
            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=35:26:18:22:21】', false, false)
                return;
            }

            //品质基数
            let qualityBaseNum = getQualityBaseNum();

            //玩家的HP要变成多少
            const playerHp = data.battleMonster.hp > data.maxHp ? getFinalNum(data.maxHp, ['红','黄','紫','绿','橙']) : getFinalNum(data.battleMonster.hp, ['红','黄','紫','绿','橙']);
            //怪物的HP要变成多少
            const monsterHp = data.hp * 2 - (getFinalNum(data.hp, ['红','黄','紫','绿','橙']));
            data.hp = playerHp;
            data.battleMonster.hp = monsterHp;
            //要眩晕的回合
            const num = 10 - rate - qualityBaseNum;

            if(num > 0){
                addStatus(data, getStatus('眩晕', {num}))
            }

            addBattleLog(`你使用了极光魔术，双方生命值发生翻转`)

            //魔术完成
            magicOver()

            return true;
        },
        text : '魔术师-璀璨种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=35:26:18:22:21】。怪物生命值变为【你的当前生命值*(2-最终效果)】，你的生命值变为【怪物的当前生命值*最终效果】，如果怪物的当前生命值比你的生命上限还要高，则你的生命值变为【你的生命上限*最终效果】，并使自己眩晕【10-倍率加值-品质基数】回合，如果回合数小于等于0则不眩晕。'
    }),
    '技能石：爆炸魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('爆炸魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({红:3,黄:2,紫:1,绿:1,橙:2});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=3:2:1:1:2】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //倍率加值
            const rate = checkGemNum({红:3,黄:2,紫:1,绿:1,橙:2});
            //添加燃烧状态
            addStatus(data.battleMonster, getStatus('眩晕', {num : (rate + getQualityBaseNum()) * 2}))
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            //倍率加值
            const rate = checkGemNum({红:3,黄:2,紫:1,绿:1,橙:2});
            return getFinalNum(getBaseAtk(0, true, true, false, getQualityBaseNum() * (rate + 1)), ['红','黄','紫','绿','橙']);
        },
        text : '魔术师-塑能种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=3:2:1:1:2】。该魔术造成【基础伤害*(1+倍率加值)*品质基数*最终效果】的伤害，并使对方眩晕【(倍率加值+品质基数)*2】回合。该技能无法触发吸血'
    }),
    '技能石：陨石魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('陨石魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({红:30,黄:55,紫:12,绿:5,橙:27});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=30:55:12:5:27】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            //倍率加值
            let rate = checkGemNum({红:30,黄:55,紫:12,绿:5,橙:27});
            if(rate < 0){
                rate = 0;
            }
            return data.battleMonster ? getFinalNum(parseInt(data.battleMonster.maxHp * (0.1 + ((rate) * 0.2) + (getQualityBaseNum() * 0.1))), ['红','黄','紫','绿','橙']) : 0;
        },
        text : '魔术师-掌控种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=30:55:12:5:27】。该魔术造成【怪物生命值上限*（0.1 + (倍率加值*0.2) + (品质基数 * 0.1))*最终效果】的伤害。该技能无法触发吸血'
    }),
    //['红','黄','紫','绿','橙']
};

//魔术师获取品质基数
function getQualityBaseNum(quality){
    const filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
    if(filter.length){
        quality = filter[0].name.replace('阵','');
    }
    return ['碎裂','裂开','完整','无瑕','完美','璀璨'].indexOf(quality) + 1;
}

//魔术师获取最终效果
function getFinalNum(harm, colors = []){
    if(!data.usedGems){
        data.usedGems = {};
    }

    //宝石类型
    let type = null;
    //获取宝石阵状态
    let filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
    //有的话，归还宝石
    if(filter.length){
        //获取状态名
        const name = filter[0].name;
        //获取宝石类型
        type = name.replace('阵', '');
    }

    if(!type){
        return harm;
    }

    let count = colors.length * 1000;
    colors.forEach(e => {
        count -= data.usedGems[type + e] || 0;
    })

    if(count < 0){
        count = 0;
    }

    return parseInt(harm * count / (colors.length * 1000));
}

//魔术师魔术完成
function magicOver(){
    if(!data.usedGems){
        data.usedGems = {};
    }
    //获取宝石阵状态
    let filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
    //有的话，归还宝石
    if(filter.length){
        //获取状态名
        const name = filter[0].name;
        //获取宝石类型
        let type = name.replace('阵', '');
        //获取所有宝石状态
        let gems = data.status.filter(e => e.name.endsWith('宝石') && e.name.length === 3);
        //循环获取宝石，并删除状态
        gems.forEach(e => {
            let gemColor = e.name.replace('宝石', '');
            const usedName = type + gemColor;

            //增加使用个数
            if(!data.usedGems[usedName]){
                data.usedGems[usedName] = 0;
            }
            data.usedGems[usedName] += e.num;

            //删除宝石状态
            removeStatus(data, e.name);
        })
        //删除宝石阵状态
        removeStatus(data, name);
    }
}

//魔术师判断宝石是否符合要求，返回-1则说明不符合要求，符合要求则返回倍率加值
function checkGemNum(ask = {}){
    const {红 = 0, 黄 = 0, 紫 = 0, 绿 = 0, 橙 = 0} = ask;
    //获取所有宝石状态
    let gems = data.status.filter(e => e.name.endsWith('宝石') && e.name.length === 3);
    if(!gems.length){
        return -1;
    }
    //获取一个有状态的宝石名字
    const oneColor = gems[0].name[0];

    //有这个状态，但是没这个要求，则不符合
    if(!ask[oneColor]){
        return -1;
    }

    //计算出倍率
    const rate = gems[0].num / ask[oneColor];

    //倍率不是整数则不符合
    if(!Number.isInteger(rate)){
        return -1;
    }

    for(const color in ask){
        //获取已有数量
        const filter = data.status.filter(e => e.name === `${color}宝石`);
        let hasNum = 0;
        if(filter.length){
            hasNum = filter[0].num;
        }

        //如果有状态，无要求，则不符合
        if(!ask[color] && hasNum){
            return -1;
        }
        //如果无状态，有要求，则不符合
        if(ask[color] && !hasNum){
            return -1;
        }
        //如果倍率乘以要求不等于状态数，则不符合
        if(rate * ask[color] !== hasNum){
            return -1;
        }
    }

    //返回倍率
    return rate - 1;
}

//魅魔的查看精气
function seeBlood(){
    if(data.blood.filter(e => monsterCfgs[e.name]).length){
        const allKey = Object.keys(monsterCfgs);
        const el = $('.common-win').show().find('.win-body');
        el.html(data.blood.filter(e => monsterCfgs[e.name]).sort((a,b) => allKey.indexOf(a.name) - allKey.indexOf(b.name)).map(e => `<div style="padding: 5px 10px">${e.name}(${e.num}%)：+${parseInt(monsterCfgs[e.name].atk * e.num / 100)}攻击，+${parseInt(monsterCfgs[e.name].def * e.num / 100)}防御，+${parseInt(monsterCfgs[e.name].hp * e.num / 1000)}HP</div>`).join(''));

        let allHas = data.blood.map(e => e.name);
        el.append(Object.keys(monsterCfgs).filter(e => !allHas.includes(e)).map(e => `<div style="padding: 5px 10px">${e}：未吸收</div>`).join(''));
    }else{
        winMsg(`你没有吸收过精气`, false, false)
    }
}

//地精万岁的核爆
function nuclearExplosion(){
    //获取到所有有效坐标
    const points = [];
    const [xp, yp] = data.location;
    for(let x = -2 ; x <= 2 ; x++){
        for(let y = -2 ; y <= 2 ; y++){
            const thisx = xp + x;
            const thisy = yp + y;
            if(thisx >= 0 && thisx < xnum && thisy >= 0 && thisy < xnum && (!data.nextPoint || `${thisx},${thisy}` !== data.nextPoint.join()) && (!data.prePoint || `${thisx},${thisy}` !== data.prePoint.join())){
                points.push([thisx,thisy])
            }
        }
    }

    let log = `会裂开的炸药爆炸了，摧毁了${points.length}个地形`;

    //循环销毁地形
    points.forEach(e => {
        //摧毁神殿
        if(data.temples[data.worldIndex][e.join()]){
            log += `，${data.temples[data.worldIndex][e.join()].name}被摧毁了`;
            delete data.temples[data.worldIndex][e.join()];
        }
        //杀死神话怪
        const myths = data.world.mythMonster.filter(m => m.location.join() === e.join());
        if(myths.length > 0){
            myths.forEach(m => {
                log += `，${m.name}被杀死了`;
                m.deathTime = new Date(data.date).getTime();
            })
        }
        //杀死NPC
        if(data.world.npcs){
            data.world.npcs.filter(n => n.location.join() === e.join()).forEach(n => {
                log += `，${n.name}被杀死了`;
            })
            data.world.npcs = data.world.npcs.filter(n => n.location.join() !== e.join())
        }
        //摧毁家
        if(data.world.home.location.join() === e.join()){
            log += '，你的家被摧毁了';
            data.world.home = {
                location : [],
                store : [],
            }
        }
        //摧毁地形
        data.map[e[1]][e[0]] = '废土';
        data.world.map[e[1]][e[0]] = '废土';
        data.world.mapElements[e.join()] = {
            elementList : [],
            monsterList : [],
            renderDates : {}
        }
    })

    winMsg(log);
    addBattleLog(log)
    renderMapElements(false, true)
    renderCanToMap();
}
